<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/CapabilityAgents/Bluetooth/include/Bluetooth/BluetoothStorageInterface.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7cf910bd1d7603f12ef47ff650cec893.html">CapabilityAgents</a></li><li class="navelem"><a class="el" href="dir_2fa9f33c88ab044378089e969c1a626c.html">Bluetooth</a></li><li class="navelem"><a class="el" href="dir_d3b0a340b0e73c93d97aa769524dbb98.html">include</a></li><li class="navelem"><a class="el" href="dir_281dbd0298ff8d441d37c56e5a5934f5.html">Bluetooth</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">BluetoothStorageInterface.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_bluetooth_storage_interface_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_CAPABILITYAGENTS_BLUETOOTH_INCLUDE_BLUETOOTH_BLUETOOTHSTORAGEINTERFACE_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_CAPABILITYAGENTS_BLUETOOTH_INCLUDE_BLUETOOTH_BLUETOOTHSTORAGEINTERFACE_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_s_q_lite_database_8h.html">SQLiteStorage/SQLiteDatabase.h</a>&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_s_q_lite_statement_8h.html">SQLiteStorage/SQLiteStatement.h</a>&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_s_q_lite_utils_8h.html">SQLiteStorage/SQLiteUtils.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>capabilityAgents {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span>bluetooth {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html">   31</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html">BluetoothStorageInterface</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a2b26aae5ee89e910fdd3a52fd265f2e5">~BluetoothStorageInterface</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ab32f31c2081a9230a8201baaa3211892">createDatabase</a>() = 0;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a2cd1b6c2097aa873227dc5b94178ffd4">open</a>() = 0;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ae5576daee25f1af3c3c711dc2b8fb215">close</a>() = 0;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ad847f26401e6e1c2e60d4801c49911d7">clear</a>() = 0;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#aac3cb2607b229e63b6598837efea1cd4">getMac</a>(<span class="keyword">const</span> std::string&amp; uuid, std::string* mac) = 0;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ab40f4e6acae90d6ff4328662b29eb8b5">getUuid</a>(<span class="keyword">const</span> std::string&amp; mac, std::string* uuid) = 0;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a078cffb948d5c56c8c2f2eb3d893ba61">getMacToUuid</a>(std::unordered_map&lt;std::string, std::string&gt;* macToUuid) = 0;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a06fecdfdbf62574061cd6c75c9de8db2">getUuidToMac</a>(std::unordered_map&lt;std::string, std::string&gt;* uuidToMac) = 0;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a51fa3ca727609b50c566de4abe68c702">getOrderedMac</a>(<span class="keywordtype">bool</span> ascending, std::list&lt;std::string&gt;* macs) = 0;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a11f978206f8da5dbeefdae60f811dd75">insertByMac</a>(<span class="keyword">const</span> std::string&amp; mac, <span class="keyword">const</span> std::string&amp; uuid, <span class="keywordtype">bool</span> overwrite) = 0;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <span class="keyword">remove</span>(<span class="keyword">const</span> std::string&amp; mac) = 0;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;};</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;}  <span class="comment">// namespace bluetooth</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;}  <span class="comment">// namespace capabilityAgents</span></div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_CAPABILITYAGENTS_BLUETOOTH_INCLUDE_BLUETOOTH_BLUETOOTHSTORAGEINTERFACE_H_</span></div><div class="ttc" id="_s_q_lite_utils_8h_html"><div class="ttname"><a href="_s_q_lite_utils_8h.html">SQLiteUtils.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_a078cffb948d5c56c8c2f2eb3d893ba61"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a078cffb948d5c56c8c2f2eb3d893ba61">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::getMacToUuid</a></div><div class="ttdeci">virtual bool getMacToUuid(std::unordered_map&lt; std::string, std::string &gt; *macToUuid)=0</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_ab40f4e6acae90d6ff4328662b29eb8b5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ab40f4e6acae90d6ff4328662b29eb8b5">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::getUuid</a></div><div class="ttdeci">virtual bool getUuid(const std::string &amp;mac, std::string *uuid)=0</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_ad847f26401e6e1c2e60d4801c49911d7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ad847f26401e6e1c2e60d4801c49911d7">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::clear</a></div><div class="ttdeci">virtual bool clear()=0</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_a06fecdfdbf62574061cd6c75c9de8db2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a06fecdfdbf62574061cd6c75c9de8db2">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::getUuidToMac</a></div><div class="ttdeci">virtual bool getUuidToMac(std::unordered_map&lt; std::string, std::string &gt; *uuidToMac)=0</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_a11f978206f8da5dbeefdae60f811dd75"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a11f978206f8da5dbeefdae60f811dd75">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::insertByMac</a></div><div class="ttdeci">virtual bool insertByMac(const std::string &amp;mac, const std::string &amp;uuid, bool overwrite)=0</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_aac3cb2607b229e63b6598837efea1cd4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#aac3cb2607b229e63b6598837efea1cd4">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::getMac</a></div><div class="ttdeci">virtual bool getMac(const std::string &amp;uuid, std::string *mac)=0</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_ab32f31c2081a9230a8201baaa3211892"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ab32f31c2081a9230a8201baaa3211892">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::createDatabase</a></div><div class="ttdeci">virtual bool createDatabase()=0</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_a2b26aae5ee89e910fdd3a52fd265f2e5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a2b26aae5ee89e910fdd3a52fd265f2e5">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::~BluetoothStorageInterface</a></div><div class="ttdeci">virtual ~BluetoothStorageInterface()=default</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_a51fa3ca727609b50c566de4abe68c702"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a51fa3ca727609b50c566de4abe68c702">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::getOrderedMac</a></div><div class="ttdeci">virtual bool getOrderedMac(bool ascending, std::list&lt; std::string &gt; *macs)=0</div></div>
<div class="ttc" id="_s_q_lite_statement_8h_html"><div class="ttname"><a href="_s_q_lite_statement_8h.html">SQLiteStatement.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_ae5576daee25f1af3c3c711dc2b8fb215"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#ae5576daee25f1af3c3c711dc2b8fb215">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::close</a></div><div class="ttdeci">virtual void close()=0</div><div class="ttdoc">Close the database. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface</a></div><div class="ttdoc">A storage interface used for Bluetooth that should provide UUID to MAC mappings and maintain insertio...</div><div class="ttdef"><b>Definition:</b> BluetoothStorageInterface.h:31</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface_html_a2cd1b6c2097aa873227dc5b94178ffd4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth_storage_interface.html#a2cd1b6c2097aa873227dc5b94178ffd4">alexaClientSDK::capabilityAgents::bluetooth::BluetoothStorageInterface::open</a></div><div class="ttdeci">virtual bool open()=0</div></div>
<div class="ttc" id="_s_q_lite_database_8h_html"><div class="ttname"><a href="_s_q_lite_database_8h.html">SQLiteDatabase.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
